from kivy.utils import platform
from kivy.uix.widget import Widget
from kivy.properties import BoundedNumericProperty, ObjectProperty

from kivy.app import App

class ListWidget(Widget):

    page = BoundedNumericProperty(1, min=1, max=10)
    mylist = ObjectProperty()

    def __init__(self, **kwargs):
        super(ListWidget, self).__init__(**kwargs)
        self.bind(page=self.update_list)
        self.update_list(None, None)

    def update_list(self, inst, value):
        if self.page == 1:
            self.mylist.adapter.data = [str(x) for x in range(40)]
        elif self.page == 2:
            self.mylist.adapter.data = [chr(x) for x in range(65, 95)]
        elif self.page == 3:
            self.mylist.adapter.data = [str(ord(str(x))) for x in range(10)]
        else:
            self.mylist.adapter.data = [str(x+self.page*20) for x in range(20)]
        # In theory, not needed
        self.mylist.populate()
        # In practice, appears required

    def next(self):
        try:
            self.page += 1
        except ValueError:
            pass

    def prev(self):
        try:
            self.page -= 1
        except ValueError:
            pass


class ListApp(App):

    def build(self):
        return ListWidget()


if __name__ == "__main__":
   ListApp().run()
